CLEAR
m.str=CheckIBAN('AT61 1904 3002 3457 3201')
IF !EMPTY(m.str)
	=MESSAGEBOX('! IBAN   :'+CHR(13)+m.str)
ELSE
	=MESSAGEBOX('IBAN  !')
ENDIF

*     _______________________________________________________
*    |    IBAN							 |
*    |_______________________________________________________|
*    |   : 24.11.04,   24.11.04         |
*    |_______________________________________________________|
FUNCTION CheckIBAN 
LPARAMETERS x
&& all-in-one check on lower text box.
&& Any blank spaces are removed before the check is done 
&& nError indicates which error message or combination of messages to display
PRIVATE errmsg,x,sCheck,CountryCode
m.errMsg=""
DIMENSION st(4)
m.x=UPPER(m.x)
m.x=RemoveBlanks(m.x)
st[1] = SUBSTR(m.x,1,2)
m.countryCode=st[1]
st[2] = SUBSTR(m.x,3,2)
st[3] = SUBSTR(m.x,5,4)
st[4] = SUBSTR(m.x,9)
m.sCheck=st[3]+st[4]+st[1]+st[2]

IF !ALPHA(st[1]) 
*	m.errMsg = "The first two characters must be alphabetic"+CHR(13)
	m.errMsg = "      A-Z."+CHR(13)
ENDIF
IF !DIGIT(st[2]) 
	m.errMsg = m.errMsg + " 3, 4   ."+CHR(13)
ENDIF
IF !AlphNum(m.sCheck)
	m.errMsg =m.errMsg+"  A-Z   0-9    IBAN."+CHR(13)
ENDIF
IF m.countryCode=="GB"
	IF !ISALPHA(st[3]) 
		m.errMsg =m.errMsg+"   = GB,   5  8    A-Z."+CHR(13)
	ENDIF
	IF LEN(m.sCheck)#22 
		m.errMsg =m.errMsg+"   = GB,  IBAN    22."+CHR(13)
	ENDIF
ENDIF
IF !checkDigitSum(m.sCheck)
	m.errMsg =m.errMsg+"  IBAN ."+CHR(13)
ENDIF
RETURN m.errMsg

FUNCTION RemoveBlanks
LPARAMETERS str
PRIVATE r,x,c
m.r=''
FOR m.x=1 TO LEN(m.str)
	m.c=SUBSTR(m.str,m.x,1)
	IF m.c#' '
		m.r=m.r+SUBSTR(m.str,m.x,1)
	ENDIF
ENDFOR
RETURN m.r

FUNCTION isEngChar
LPARAMETERS c
RETURN (ASC(m.c)>=ASC('A') AND ASC(m.c)<=ASC('Z'))

FUNCTION Alpha
LPARAMETERS str
PRIVATE x,c
FOR m.x=1 TO LEN(m.str)
	m.c=SUBSTR(m.str,m.x,1)
	IF !isEngChar(m.c)
		RETURN .f.
	ENDIF
ENDFOR
RETURN .t.

FUNCTION Digit
LPARAMETERS str
PRIVATE x,c
FOR m.x=1 TO LEN(m.str)
	m.c=SUBSTR(m.str,m.x,1)
	IF !ISDIGIT(m.c)
		RETURN .f.
	ENDIF
ENDFOR
RETURN .t.

FUNCTION AlphNum
LPARAMETERS str
PRIVATE x,c
FOR m.x=1 TO LEN(m.str)
	m.c=SUBSTR(m.str,m.x,1)
	IF !ISDIGIT(m.c) AND !isEngChar(m.c)
		RETURN .f.
	ENDIF
ENDFOR
RETURN .t.

FUNCTION checkDigitSum
LPARAMETERS s
&& replace each letter by numerical equivalent to create new string newS
PRIVATE n,news,i,a,n,newm,r
m.newS = ""
FOR i = 1 TO LEN(s)
	m.a = ASC(SUBSTR(m.s,m.i,1))
	IF (a>=65) AND (a<=90)
		m.n = m.a - 55
	ELSE 
		m.n = VAL(SUBSTR(m.s,m.i,1))
	ENDIF
	m.newS = m.newS + ALLTRIM(STR(m.n))
ENDFOR
&& check digit sum by long division, starting with first two digits
m.newM=VAL(SUBSTR(m.newS,1,2))
m.r=MOD(m.newM,97)
FOR m.i = 3 TO LEN(m.news)
	m.newM = 10*m.r + VAL(SUBSTR(m.newS,m.i,1))
	m.r=MOD(m.newM,97)
ENDFOR
RETURN m.r=1
